#include <bits/stdc++.h>
using namespace std;
int masiv[1001];
vector<pair<int,int>> dirr(4);
int main(){
    dirr[0]= { 0,1};
    dirr[1]= {1,0};
    dirr[2]={0,-1};
    dirr[3]={-1,0};
    int d=0;
    int m,n,p;
    cin>>m>>n>>p;
    int maksx=n-1,minx=0,maksy=n-1,miny=0;
    for(int x=0,y=0;true;){
        //cout<<x<<" "<<y<<" "<<d<<endl;
        masiv[x]+=m;
        if(x+dirr[d].first<=maksx && y+dirr[d].second<=maksy && x+dirr[d].first>=minx && y+dirr[d].second>=miny){
            x+=dirr[d].first;
            y+=dirr[d].second;
        }else{
            if(d==0){
                minx=x+1;
            }
            if(d==1){
                maksy=y-1;
            }
            if(d==2){
                maksx=x-1;
            }
            if(d==3){
                miny=y+1;
            }
            d++;
            d%=4;
            x+=dirr[d].first;
            y+=dirr[d].second;
            if(x<minx || x>maksx || y<miny || y>maksy){
                break;
            }

        }
        m++;
        /*for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                cout<<masiv[i][j]<<" ";
            }
            cout<<endl;
        }*/
    }
    cout<<masiv[p-1]<<endl;
    /*for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                cout<<masiv[i][j]<<" ";
            }
            cout<<endl;
    }*/
    return 0;
}
